var bizagiUtil = require('bz-util');
var REQUIRED = bizagiUtil.REQUIRED;
var ERROR = bizagiUtil.error;
var RESPONSE = bizagiUtil.getResponse;
 
/**
 * @author luis.avila@bizagi.com
 */ 

function invoke(globals, actionName, data, authenticationType, LOG, callback) {
    
var Client = REQUIRED('node-rest-client').Client;
var clientRest = new Client();

var API_KEY = globals.authdata.API_KEY
var query = data.inputs.input.query;

var args = {
    headers: {
        'Content-Type': 'application/json'
    }
};

clientRest.get("https://api.nytimes.com/svc/search/v2/articlesearch.json?api-key=" + API_KEY + '&q=' + query,
    args, function (data, response) {
        if (data.status && data.status == 'OK' && data.response) {
            var success = RESPONSE(data.response.docs, null, 200);
            callback(success);
        } else if (data.message) {
            var errorData = {error: data.message, code: 400};
            var error = RESPONSE(null, errorData, errorData.code, errorData.error);
            callback(error);
        } else {
            var errorData = {error: 'Error', code: 500};
            var error = RESPONSE(null, errorData, 400, errorData.error);
            callback(error);
        }
    });

}

exports.invoke = invoke;